'''

Example: from user-activity matrix to user similarity

implement the agreement function 

'''

import numpy as np
from scipy import linalg as la
#import scipy.special


def agreement(mat):
	""" take a rating matrix and produce a co-rating matrix 
	 where m_ij != 0 when users i and j have rated the same film.
	 Value of m_ij should reflect agreement.
	 Idea: 1 for scarce agreement, 4 for full agreement.
	"""

	return np.dot(mat, mat.T)

def main():

	ratings =  [[1, 1, 1, 0, 0],
				[3, 3, 3, 0, 0],
				[4, 4, 4, 0, 0],
				[5, 5, 5, 0, 0],
				[0, 0, 0, 4, 4],
				[0, 0, 0, 5, 5],
				[0, 0, 0, 2, 2]]

	ratings2 =  [[1, 1, 1, 0, 0],
				[3, 3, 3, 0, 0],
				[4, 4, 4, 0, 0],
				[5, 5, 5, 0, 0],
				[0, 2, 0, 4, 4],
				[0, 0, 0, 5, 5],
				[0, 1, 0, 2, 2]]
				

	ratings = np.array(ratings)

	sim_users = agreement(ratings)
 

	find_eigenpairs(sim_users)



def find_eigenpairs(mat):
	"""
		Testing the quality of eigenvector/eigenvalue computation by numpy
	"""

	n = len(mat)

	m = len(mat[0])

	eig_vals, eig_vects = la.eig(mat)

	# they come in ascending order, take the last one on the right
	dominant_eig = abs(eig_vals[-1])

	print(dominant_eig)

	print(eig_vals)

	# DO: for generality, filter the eig_vals list to keep real eigenvalues only

	print(np.real(eig_vals))


main()